
package features.tool;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.InputEvent;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;
import java.util.Random;
import java.util.Timer;

import javax.swing.JButton;
import javax.swing.JPanel;

import com.steema.teechart.Cursor;
import com.steema.teechart.DateTime;
import com.steema.teechart.Dimension;
import com.steema.teechart.drawing.Color;
import com.steema.teechart.drawing.DashCap;
import com.steema.teechart.drawing.DashStyle;
import com.steema.teechart.drawing.IGraphics3D;
import com.steema.teechart.drawing.LineCap;
import com.steema.teechart.drawing.Point;
import com.steema.teechart.drawing.StringAlignment;
import com.steema.teechart.events.ChangeEvent;
import com.steema.teechart.events.ChangeListener;
import com.steema.teechart.styles.Candle;
import com.steema.teechart.styles.Series;
import com.steema.teechart.styles.SeriesOHLCPoint;
import com.steema.teechart.styles.StringList;
import com.steema.teechart.themes.ThemesList;
import com.steema.teechart.tools.Annotation;
import com.steema.teechart.tools.AnnotationCallout;
import com.steema.teechart.tools.AnnotationPosition;
import com.steema.teechart.tools.NearestPoint;
import com.steema.teechart.tools.NearestPointDirection;
import com.steema.teechart.tools.ScrollPager;

import features.ChartSamplePanel;

/**
 * 
 * @author Steema Software 2011
 */
public class ScrollPagerDemo extends ChartSamplePanel implements ActionListener, ItemListener, ChangeListener
{

	ScrollPager			tool1;
	private Annotation	annoTool;



	//FastLine tmpSeries;
	Candle				tmpSeries;

	Annotation			annotate;
	NearestPoint		point;
	private JButton		leftTopButton, leftTopButton2;
	boolean				scaled	= false;


	List<Point>			points	= new ArrayList();




	public void actionPerformed(ActionEvent e)
	{
		Object source = e.getSource();

		if (source == leftTopButton)
		{


			for (int i = 0; i < 60; i++)
			{
				setCallout(tmpSeries, i);
			}


			return;
		}


		if (scaled == true)
		{
			return;
		}

		scaled = true;
		Candle cc = (Candle) tool1.getSubChartTChart().getChart().getSeries(0);
		cc.setUpCloseColor(Color.yellow);
		cc.setDownCloseColor(Color.yellow);

		java.awt.Dimension d = (java.awt.Dimension) tool1.getSubChartTChart().getSize();
		int h = (int) d.getHeight();
		int w = (int) d.getWidth();

		Dimension newD = new Dimension(w, h / 2);
		tool1.getSubChartTChart().setSize(newD);
		tool1.getSubChartTChart().setPreferredSize(newD);

	}




	private void setCallout(Series aSeries, int aIndex)
	{



		SeriesOHLCPoint ohlc = tmpSeries.getOHLCPoint(aIndex);
		double hi = ohlc.getHigh();

		annoTool = new Annotation(chart1.getChart());

		// Re-position annotation callout
		annoTool.getShape().setCustomPosition(true);
		annoTool.getShape().setColor(Color.YELLOW);
		annoTool.getShape().getShadow().setHorizSize(0);
		annoTool.getShape().getShadow().setVertSize(0);
		annoTool.getShape().getPen().setVisible(false);
		annoTool.setCursor(Cursor.CROSS);
		annoTool.setWidth(28);
		annoTool.setHeight(21);
		annoTool.setLeft(aSeries.calcXPos(aIndex));
		annoTool.setTop(aSeries.calcYPosValue(hi) - 28);
		annoTool.setText("[" + String.format("%4s", "" + aIndex) + "]");
		/*
				AnnotationCallout tmpCallout = annoTool.getCallout();		
		        tmpCallout.setVisible(true);
				tmpCallout.setVisible(true);
				tmpCallout.setXPosition(aSeries.calcXPos(aIndex));
				tmpCallout.setYPosition(aSeries.calcYPosValue(hi));
				tmpCallout.setDraw3D(false);
				tmpCallout.setDark3D(false);
		*/


		annotate = new Annotation(chart1.getChart());
		annotate.setPosition(AnnotationPosition.RIGHTTOP);
		annotate.getShape().getFont().setColor(chart1.getHeader().getColor());
		annotate.getShape().setColor(tool1.getPointerHighlightColor());
		annotate.getShape().getPen().setVisible(false);
		annotate.setTextAlign(StringAlignment.CENTER);
		annotate.setText("[" + 1234 + "]");


		chart1.repaint();


	}




	public void itemStateChanged(ItemEvent e)
	{

		Object source = e.getItemSelectable();
		boolean isSelected = (e.getStateChange() == ItemEvent.SELECTED);

		if (source == leftTopButton)
		{
			tool1.setActive(isSelected);
		}


	}




	/**
	 * Creates a new instance of AxisBreakDemo
	 */
	public ScrollPagerDemo()
	{
		super();
		addComponentListener(new java.awt.event.ComponentAdapter()
		{

			public void componentResized(java.awt.event.ComponentEvent evt)
			{
				scrollPagerDemoResized(evt);
			}
		});
	}




	private void scrollPagerDemoResized(java.awt.event.ComponentEvent evt)
	{
		if (tool1.getSeries() == null)
		{
			tool1.setSeries(tmpSeries);
			ThemesList.applyTheme(tool1.getSubChartTChart().getChart(), 1);
		}
	}




	protected void initComponents()
	{
		super.initComponents();

		chart1.getChart().getAspect().setView3D(false);
		chart1.getChart().getLegend().setVisible(false);


		tmpSeries = new Candle(chart1.getChart());

		tmpSeries.setDownCloseColor(Color.yellow);
		tmpSeries.setUpCloseColor(Color.yellow);

		tmpSeries.setColorEachLine(true);


		StringList labels = new StringList(10);


		labels.add("08/05/2008");
		labels.add("09/05/2008");
		labels.add("12/05/2008");
		labels.add("13/05/2008");
		labels.add("14/05/2008");
		labels.add("15/05/2008");
		labels.add("16/05/2008");
		labels.add("19/05/2008");
		labels.add("20/05/2008");
		labels.add("21/05/2008");
		labels.add("08/05/2008");
		labels.add("09/05/2008");
		labels.add("12/05/2008");
		labels.add("13/05/2008");
		labels.add("14/05/2008");
		labels.add("15/05/2008");
		labels.add("16/05/2008");
		labels.add("19/05/2008");
		labels.add("20/05/2008");
		labels.add("21/05/2008");
		labels.add("08/05/2008");
		labels.add("09/05/2008");
		labels.add("12/05/2008");
		labels.add("13/05/2008");
		labels.add("14/05/2008");
		labels.add("15/05/2008");
		labels.add("16/05/2008");
		labels.add("19/05/2008");
		labels.add("20/05/2008");
		labels.add("21/05/2008");

		/* no dates */
		tmpSeries.getXValues().setDateTime(false);
		chart1.getAxes().getBottom().getLabels().setAngle(0);

		/* fill the candle with random points */
		Random generator = new Random();

		double tmpOpen, tmpClose;
		tmpOpen = 1000;

		DateTime dt = new DateTime(2008, 5, 8);
		int count = 0;

		for (int t = 0; t < 60; t++)
		{
			tmpOpen = tmpOpen + generator.nextDouble() * 100 - 50;
			tmpClose = tmpOpen - generator.nextDouble() * 100 + 50;

			if ((dt.getDayOfWeek() != Calendar.SATURDAY) && (dt.getDayOfWeek() != Calendar.SUNDAY) || true)
			{
				++count;

				/* add the point */
				tmpSeries.add(count, tmpOpen, tmpOpen + generator.nextDouble() * 10, tmpClose - generator.nextDouble() * 10, tmpClose);
				System.out.println(String.format("%2d  %4f", t, tmpOpen + generator.nextDouble() * 10));
			}

			dt.add(7, 1);

			tmpSeries.setLabels(labels);
		}




		SeriesOHLCPoint ohlc = tmpSeries.getOHLCPoint(3);
		double close = ohlc.getHigh();
		String lable = ohlc.getLabel();

		double dval = tmpSeries.getXValues().getValue(3);

		tmpSeries.getMarks().setVisible(false);

		tool1 = new MyScrollPager(chart1.getChart(), tmpSeries);




		//	cc.setDownCloseColor(Color.BLACK);
		//	cc.setUpCloseColor(Color.BLACK);


		point = new NearestPoint(chart1.getChart());
		point.getBrush().setVisible(true);
		point.getBrush().setColor(tool1.getPointerHighlightColor());
		point.setDrawLine(false);
		point.setSize(6);
		point.setDirection(NearestPointDirection.HORIZONTAL);
		point.setSeries(tmpSeries);
		point.addChangeListener(this);

		leftTopButton2 = new JButton("Z+/-");

		leftTopButton = new JButton("Edit...");
		leftTopButton.addActionListener(this);
		leftTopButton2.addActionListener(this);

		ThemesList.applyTheme(chart1.getChart(), 1);


		chart1.addMouseListener(new MouseAdapter()
		{

			public void mouseClicked(MouseEvent e)
			{
				int whichButton = e.getButton();

				int ex = e.getX();
				int ey = e.getY();
				int index = tmpSeries.clicked(e.getX(), e.getY());

				if (index != -1)
				{
					int xx = (int) tmpSeries.getXValues().getValue(index);
					System.out.println("x,y = " + index + ", " + 0);
				}
				else
					System.out.println("index = -1 ");




				int modifiers = e.getModifiers();
				if ((modifiers & InputEvent.BUTTON1_MASK) == InputEvent.BUTTON1_MASK)
				{
					System.out.println("Left button pressed.");
				}
				if ((modifiers & InputEvent.BUTTON2_MASK) == InputEvent.BUTTON2_MASK)
				{
					System.out.println("Middle button pressed.");
				}
				if ((modifiers & InputEvent.BUTTON3_MASK) == InputEvent.BUTTON3_MASK)
				{
					System.out.println("Right button pressed.");
				}

				IGraphics3D g = chart1.getGraphics3D();
				g.triangle(new Point(500, 1000), new Point(502, 1200), new Point(504, 1100), 0);


				g.getPen().setDashCap(DashCap.SQUARE);
				g.getPen().setEndCap(LineCap.MITER);
				g.getPen().setStyle(DashStyle.DASH);
				g.getPen().setTransparency(70);
				g.getPen().setWidth(1);
				g.getPen().setColor(Color.red);



				int x1;
				int y1;
				int x2;
				int y2;
				int x3;
				int y3;


				Point s = null;
				Point en = null;

				for (int i = 1; i < 5; i++)
				{
					for (int j = 0; j < 100; j++)
					{
						x1 = tmpSeries.calcXPosValue(i);
						y1 = tmpSeries.calcYPosValue(980);
						x2 = tmpSeries.calcXPosValue(i);
						y2 = tmpSeries.calcYPosValue(960);

						g.getPen().setColor(Color.red);

						s = new Point(x1, y1);
						en = new Point(x2, y2);



						g.moveTo(s);
						g.lineTo(en);

						x1 = tmpSeries.calcXPosValue(i);
						y1 = tmpSeries.calcYPosValue(980);
						x2 = tmpSeries.calcXPosValue(i + 4);
						y2 = tmpSeries.calcYPosValue(980);

						s = new Point(x1, y1);
						en = new Point(x2, y2);



						g.moveTo(s);
						g.lineTo(en);



						x1 = tmpSeries.calcXPosValue(2);
						y1 = tmpSeries.calcYPosValue(980);
						x2 = tmpSeries.calcXPosValue(4);
						y2 = tmpSeries.calcYPosValue(1000);
						x3 = tmpSeries.calcXPosValue(6);
						y3 = tmpSeries.calcYPosValue(960);

						g.getPen().setColor(Color.blue);


						s = new Point(x1, y1);
						en = new Point(x2, y2);

						g.moveTo(s);
						g.lineTo(en);



						s = new Point(x2, y2);
						en = new Point(x3, y3);

						g.moveTo(s);
						g.lineTo(en);


						s = new Point(x1, y1);
						en = new Point(x3, y3);

						g.moveTo(s);
						g.lineTo(en);




						chart1.repaint();
					}

				}
			}
		});

	}




	protected void initGUI()
	{
		super.initGUI();
		JPanel tmpPane = getButtonPane();
		{
			tmpPane.add(leftTopButton);
			tmpPane.add(leftTopButton2);
		}
	}




	public void stateChanged(ChangeEvent e)
	{
		if (point.point > -1)
		{
			if (annotate == null)
				return;
			annotate.setText("YValue: " + tmpSeries.getYValues().getValue(point.point));



		}




	}
}
